import java.util.*;

public class kohonen extends clusteringAlgorithm{
   /* Size of clustersmap */
   private int n;
   // number of epochs
   private int epochs;
   // Dimensionality of the vectors
   private int dim;
   // Threshold above which the corresponding html is prefetched
   private double prefetchThreshold;
   double initialLearningRate; 
   
    // This class represents the clusters, it contains the prototype (the mean of all it's members)
   // and a memberlist with the ID's (Integer objects) of the datapoints that are member of that cluster.  
   private cluster[][] clusters;
   static class cluster{
        float[] prototype;
        Vector currentMembers;
        public cluster(){
            currentMembers = new Vector();
        }
    }
   
   // Vector which contains the train/test data
   private Vector trainData;
   private Vector testData;
   // results of test
   double hitrate;
   double accuracy;
   
   public kohonen(int n, int epochs, Vector trainData, Vector testData, int dim){
        this.n = n;
        this.epochs = epochs;
        prefetchThreshold = 0.5;
        initialLearningRate = 0.8;
        this.trainData = trainData;
        this.testData = testData; 
        this.dim = dim;       
        
        // Here n*n new cluster are initialized
        Random rnd = new Random();
        clusters = new cluster[n][n];
        for(int i=0; i< n; i++){ 
            for(int i2=0; i2< n; i2++){        
                clusters[i][i2] = new cluster(); 
                clusters[i][i2].prototype = new float[dim];               
            }
        }
   }

   
   public boolean train(){
        // Step 1: initialize map with random vectors (A good place to do this, is in the initialisation of the clusters)
        // Repeat 'epochs' times:
          // Step 2: Calculate the squareSize and the learningRate, these decrease lineary with the number of epochs.
          // Step 3: Every input vector is presented to the map (always in the same order)
          // For each vector its Best Matching Unit is found, and :
            // Step 4: All nodes within the neighbourhood of the BMU are changed, you don't have to use distance relative learning.
        // Since training kohonen maps can take quite a while, presenting the user with a progress bar would be nice
        return true;
   }
   
   public boolean test(){
      // iterate along all clients
       // for each client find the cluster of which it is a member
       // get the actual testData (the vector) of this client
       // iterate along all dimensions
       // and count prefetched htmls
       // count number of hits
       // count number of requests
       // set the global variables hitrate and accuracy to their appropriate value
       return true;
   }


   public void showTest(){
       System.out.println("Initial learning Rate="+initialLearningRate);
       System.out.println("Prefetch threshold="+prefetchThreshold);
       System.out.println("Hitrate: "+hitrate);
       System.out.println("Accuracy: "+accuracy);
       System.out.println("Hitrate+Accuracy="+(hitrate+accuracy));
   }
 
 
   public void showMembers() {
        for(int i=0; i < n; i++){
            for(int i2=0; i2 < n; i2++)
                    System.out.println("\nMembers cluster["+i+"]["+i2+"] :"+clusters[i][i2].currentMembers);
        }
    }    

    public void showPrototypes() {
      for(int i=0; i < n; i++){
        for(int i2=0; i2 < n; i2++){
           System.out.print("\nPrototype cluster["+i+"]["+i2+"] :");
           for(int i3=0;i3 < dim; i3++)
                       System.out.print(" "+clusters[i][i2].prototype[i3]);    
           System.out.println();
        }
      }
    }    

     public void setPrefetchThreshold(double prefetchThreshold){
        this.prefetchThreshold = prefetchThreshold;
    }
}
